@ECHO OFF
TITLE = "UnMech3 Updater"
MODE con:cols=70 lines=30

:::::::::::::::::::::::::::::::::::::::::::::::::::::
::-------------------------------------------------::
::---                                           ---::
::---       UnMech3 Updater                     ---::
::---           Made because i care             ---::
::-------------------------------------------------::
::---                                           ---::
::---       Made By:                            ---::
::---                "Eledore Massis"           ---::
::---                                           ---::
::---   For easy installing and update UnMech3  ---::
::---                                           ---::
::-------------------------------------------------::
::---                                           ---::
::---  To use this file place it in the         ---::
::---   MW3 installation directory.             ---::
::---  E.G; C:\MicroProse\MechWarrior3          ---::
::---   And run this batch file                 ---::
::---                                           ---::
::-------------------------------------------------::
:::::::::::::::::::::::::::::::::::::::::::::::::::::

:: Setting COLOR to 'A' Light Green '0' Black
COLOR A0


:variables
:: Setting Variables
SET dir=%CD%
SET dsd=%TMP%\UM3
SET dev=%1
SET upver=13
SET pw=UM3
GOTO SETUP


:SETUP
:: create Temp directory if not already existing
MKdir %dsd% >nul 2>&1 
GOTO PRE-CLEANUP


:PRE-CLEANUP
:: pre-cleanup
CD %dsd% >nul 2>&1 
:: text files
DEL /q %dsd%\version.tet  >nul 2>&1 
:: executables
DEL /q %dsd%\main.txe >nul 2>&1 
DEL /q %dsd%\warning.bat >nul 2>&1 
GOTO DEV-SET


:DEV-SET
:: Checking dev variables
:: If 'd' dev variable is used. Enable Developer-Mode
ECHO.%dev%| FIND /I "d">Nul && (GOTO DEV-SET-YES) || (GOTO DETECT)
GOTO DETECT


:DEV-SET-YES
:: Pull all data from Updater Developer FTP account
:: Set FTP Password
SET pw=UMDEV
CLS
COLOR 80
ECHO.%dev%
ECHO.     _     _   
ECHO.    !_;___;_!  
ECHO.   .=:!.-.!:=.   _     _        ______             _        ________
ECHO.   H  "'-'"  H  ! !   ! !       !  ___ \           ! !     (_______/
ECHO.  [o]{/'"'\}[o] ! !   ! !____   ! ! _ ! ! ____ ____! ! _      ____  
ECHO.     d     b    ! !   ! !  _ \  ! !! !! !/ _  ) ___) !! \    (___ \ 
ECHO.    !M     M!   ! !___! ! ! ! ! ! !! !! ( (/ ( (___! ! ! !  _____) )
ECHO.    O       O    \______!_! !_! !_!!_!!_!\____)____)_! !_! (______/ 
ECHO.   .A.     .A. 
ECHO.-------------------------------------------------
ECHO.---   UnMech3 Fetching Latest Script          ---
ECHO.-------------------------------------------------
ECHO.---                                           ---
ECHO.---   DEV FLAG SET...                         ---
ECHO.---                                           ---
ECHO.-------------------------------------------------
PAUSE
GOTO FTP-UPDATE


:DETECT
ECHO.%dev%
ECHO.     _     _   
ECHO.    !_;___;_!  
ECHO.   .=:!.-.!:=.   _     _        ______             _        ________
ECHO.   H  "'-'"  H  ! !   ! !       !  ___ \           ! !     (_______/
ECHO.  [o]{/'"'\}[o] ! !   ! !____   ! ! _ ! ! ____ ____! ! _      ____  
ECHO.     d     b    ! !   ! !  _ \  ! !! !! !/ _  ) ___) !! \    (___ \ 
ECHO.    !M     M!   ! !___! ! ! ! ! ! !! !! ( (/ ( (___! ! ! !  _____) )
ECHO.    O       O    \______!_! !_! !_!!_!!_!\____)____)_! !_! (______/ 
ECHO.   .A.     .A. 
ECHO.-------------------------------------------------
ECHO.---   UnMech3 Fetching Latest Script          ---
ECHO.-------------------------------------------------
ECHO.---                                           ---
ECHO.---   Please Standing By...                   ---
ECHO.---                                           ---
ECHO.-------------------------------------------------
TIMEOUT /T 2 >nul 2>&1
:: IF 'x' dev variable is used, Bypass is game running step.
:: x variable will force close the game and update
ECHO.%dev%| FIND /I "x">Nul && (GOTO FTP-UPDATE) || (ECHO.)
:: Check if UnMech3.exe is already running
QPROCESS "UnMech3.exe">NUL
IF %ERRORLEVEL% EQU 0 GOTO DETECTED
:: Set FTP Password
GOTO FTP-UPDATE


:FTP-UPDATE
:: Updating Text and Connectivity files.


:: Download script for files.
> %dsd%\update.um3 ECHO %pw%
>>%dsd%\update.um3 ECHO %pw%
>>%dsd%\update.um3 ECHO lcd %dsd%
>>%dsd%\update.um3 ECHO cd updater
>>%dsd%\update.um3 ECHO binary
>>%dsd%\update.um3 ECHO get warning.bat
>>%dsd%\update.um3 ECHO get main.txe
>>%dsd%\update.um3 ECHO get UnMech3.ico
>>%dsd%\update.um3 ECHO quit
CLS
ECHO.%dev%
ECHO.     _     _   
ECHO.    !_;___;_!  
ECHO.   .=:!.-.!:=.   _     _        ______             _        ________
ECHO.   H  "'-'"  H  ! !   ! !       !  ___ \           ! !     (_______/
ECHO.  [o]{/'"'\}[o] ! !   ! !____   ! ! _ ! ! ____ ____! ! _      ____  
ECHO.     d     b    ! !   ! !  _ \  ! !! !! !/ _  ) ___) !! \    (___ \ 
ECHO.    !M     M!   ! !___! ! ! ! ! ! !! !! ( (/ ( (___! ! ! !  _____) )
ECHO.    O       O    \______!_! !_! !_!!_!!_!\____)____)_! !_! (______/ 
ECHO.   .A.     .A. 
ECHO.-------------------------------------------------
ECHO.---   UnMech3 Fetching Latest Script          ---
ECHO.-------------------------------------------------
ECHO.---                                           ---
ECHO.---   Downloading...                          ---
ECHO.---                                           ---
ECHO.-------------------------------------------------
:: FTP script executable
FTP -v -s:%dsd%\update.um3 eledore.info >nul 2>&1 
:: Remove FTP Script
DEL /q %dsd%\update.um3  >nul 2>&1 
GOTO CLEANUP


:CLEANUP
DEL /q %dsd%\main.bat >nul 2>&1 
COPY %dsd%\main.txe %dsd%\main.bat >nul 2>&1 
START /wait %dsd%\warning.bat %upver% %dev% >nul 2>&1 
DEL /q %dsd%\main.txe >nul 2>&1 
DEL /q %dsd%\warning.bat >nul 2>&1 
GOTO RUN


:ERROR
CLS
COLOR 4f
ECHO.%dev%
ECHO.-------------------------------------------------
ECHO.---            ~!~ WARNING ~!~                ---
ECHO.-------------------------------------------------
ECHO.---                                           ---
ECHO.---     UnMech3 Updater                       ---
ECHO.---   Something Went Wrong!                   ---
ECHO.---   Please contact a UnMech3 Developer      ---
ECHO.---                                           ---
ECHO.-------------------------------------------------
ECHO.---    Where to get Help?                     ---
ECHO.---                                           ---
ECHO.---    Discord                                ---
ECHO.---     MechWarrior 3 Community Project       ---
ECHO.---         https://discord.gg/wxcHxE9m2F     ---
ECHO.---           #operatio_damocles              ---
ECHO.-------------------------------------------------
COLOR A0
GOTO END


:DETECTED
CLS
color 4f
ECHO.%dev%
ECHO.-------------------------------------------------
ECHO.---            ~!~ WARNING ~!~                ---
ECHO.-------------------------------------------------
ECHO.---                                           ---
ECHO.---     UnMech3 Updater                       ---
ECHO.---   Has detected a UnMech3 Already running  ---
ECHO.---                                           ---
ECHO.-------------------------------------------------
ECHO.---                                           ---
ECHO.---   I can't update with the game running    ---
ECHO.---   Please close UnMech3.exe and try again  ---
ECHO.---                                           ---
ECHO.-------------------------------------------------
ECHO.---   Have problems with UnMech3              ---
ECHO.---     Tell us about it!                     ---
ECHO.---                                           ---
ECHO.---    Discord                                ---
ECHO.---     MechWarrior 3 Community Project       ---
ECHO.---         https://discord.gg/wxcHxE9m2F     ---
ECHO.---           #operatio_damocles              ---
ECHO.-------------------------------------------------
PAUSE
color A0
GOTO END


:RUN
START %dsd%\main.bat "%dir%" "%dev%"
EXIT


:END
CLS
EXIT